#******************************************************
# Generate a CSV file from an ecosystem
# 
# - csvtoeco.py
# - By Mark Caldwell
# - Version 0.2
# - 4th July 2006
# - Tested with Vue 5 Infinite 5.10, Vue 6 Pre Release and Vue 7 Infinite
#
# How to use in 4 easy steps
#
# 1. Download this file onto your computer
#
# 2. Edit the configuration variable file to set where the file was saved
#
# 3. Select an object with a populated EcoSystem applied
#
# 4. Then run script and wait for it to work
#    To run it go to Python -> Run Python Script
#    Then locate the file on your computer
#
#******************************************************

#----------------------------------------------
# Configuration: Set these to alter end result
#----------------------------------------------

file='C:\Program Files\e-on software\Vue 5 Infinite\Python\Scripts\Impworks\ecotocsv2\eco.csv'          # Full Path to where you want the CSV data loaded from

file='C:\Users\mark\Documents\e-on software\launched python scripts\ecocsv\ecocsv\eco.csv'          # Full Path to where you want the CSV data loaded from


#--------------------------------------------------------------------------
# Test the user has a scene loaded
#--------------------------------------------------------------------------

if TestLoaded(): 

#--------------------------------------------------------------------------
# Test the user has 1 object selected with an Eco System on it
#--------------------------------------------------------------------------

    numselected=CountSelectedObjects()

    if numselected>1:
        message="Please select only one object."
    elif numselected<1:
        message="Please select an object."
    else:

#--------------------------------------------------------------------------
#Set Up a Few Variables
#--------------------------------------------------------------------------

        bObject=GetSelectedObjectByIndex(0)     # Get first selected object
        Eco = GetEcosystemOnObject(bObject)     # Get EcoSystem on first selected 

        objlist=[bObject]

        if Eco==None:
            message="Please select an object with an EcoSystem material applied to it."
        elif bObject.IsLocked():                # Check object isn't locked
            message="Please select an object that isn't locked."
        else:
            ecocount=Eco.GetInstanceCount ()            # Count number of instances in EcoSystem
            
#--------------------------------------------------------------------------
# Apply to Instances
#--------------------------------------------------------------------------

            file=open(file,'r')
            count=0
            check=0

            line = file.readline() # Throw away the header line
            
            message="CSV to Eco Successful"

            while 1:
                line = file.readline()
                if not(line):
                    break

                line=line.strip()
                
                bits=line.split(',')

                if int(bits[0])<=ecocount and str(bits[11])=='T':
                    name=int(bits[0])
                    x=float(bits[1])
                    y=float(bits[2])
                    z=float(bits[3])
                    rx=float(bits[4])
                    ry=float(bits[5])
                    rz=float(bits[6])
                    sx=float(bits[7])
                    sy=float(bits[8])
                    sz=float(bits[9])

                    Eco.SetInstancePosition(name,x,y,z)
                    Eco.SetInstanceRotation(name,rx,ry,rz)
                    Eco.SetInstanceScale(name,sx,sy,sz)
                elif int(bits[0])<=ecocount and str(bits[11])=='D':
                    name=int(bits[0])
                    Eco.DeleteInstance  (name)  
                else:
                    message="CSV to Eco Fail"
                    break  
            Refresh()
else:
    message="No Scene Loaded"
                    
Message(message)    # Display message
       
#--------------------------------------------------------------------------
# End of Script
#--------------------------------------------------------------------------
                



    
                









    
 

